home *** CD-ROM | disk | FTP | other *** search
/ PC World Komputer 2010 April / PCWorld0410.iso / hity wydania / Ubuntu 9.10 PL / karmelkowy-koliberek-desktop-9.10-i386-PL.iso / casper / filesystem.squashfs / usr / bin / ldd < prev    next >
Text File  |  2009-10-07  |  6KB  |  216 lines

  1. #! /bin/bash
  2. # Copyright (C) 1996-2008, 2009 Free Software Foundation, Inc.
  3. # This file is part of the GNU C Library.
  4.  
  5. # The GNU C Library is free software; you can redistribute it and/or
  6. # modify it under the terms of the GNU Lesser General Public
  7. # License as published by the Free Software Foundation; either
  8. # version 2.1 of the License, or (at your option) any later version.
  9.  
  10. # The GNU C Library is distributed in the hope that it will be useful,
  11. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  12. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  13. # Lesser General Public License for more details.
  14.  
  15. # You should have received a copy of the GNU Lesser General Public
  16. # License along with the GNU C Library; if not, write to the Free
  17. # Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
  18. # 02111-1307 USA.
  19.  
  20.  
  21. # This is the `ldd' command, which lists what shared libraries are
  22. # used by given dynamically-linked executables.  It works by invoking the
  23. # run-time dynamic linker as a command and setting the environment
  24. # variable LD_TRACE_LOADED_OBJECTS to a non-empty value.
  25.  
  26. # We should be able to find the translation right at the beginning.
  27. TEXTDOMAIN=libc
  28. TEXTDOMAINDIR=/usr/share/locale
  29.  
  30. RTLDLIST="/lib/ld-linux.so.2 /lib64/ld-linux-x86-64.so.2"
  31. warn=
  32. bind_now=
  33. verbose=
  34. filename_magic_regex="((^|/)lib|.so$)"
  35.  
  36. while test $# -gt 0; do
  37.   case "$1" in
  38.   --vers | --versi | --versio | --version)
  39.     echo 'ldd (EGLIBC) 2.10.1'
  40.     printf $"Copyright (C) %s Free Software Foundation, Inc.
  41. This is free software; see the source for copying conditions.  There is NO
  42. warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  43. " "2009"
  44.     printf $"Written by %s and %s.
  45. " "Roland McGrath" "Ulrich Drepper"
  46.     exit 0
  47.     ;;
  48.   --h | --he | --hel | --help)
  49.     printf $"Usage: ldd [OPTION]... FILE...
  50.       --help              print this help and exit
  51.       --version           print version information and exit
  52.   -d, --data-relocs       process data relocations
  53.   -r, --function-relocs   process data and function relocations
  54.   -u, --unused            print unused direct dependencies
  55.   -v, --verbose           print all information
  56. "
  57.     printf $"For bug reporting instructions, please see:
  58. %s.
  59. " "<http://www.eglibc.org/issues/>"
  60.     exit 0
  61.     ;;
  62.   -d | --d | --da | --dat | --data | --data- | --data-r | --data-re | \
  63.   --data-rel | --data-relo | --data-reloc | --data-relocs)
  64.     warn=yes
  65.     shift
  66.     ;;
  67.   -r | --f | --fu | --fun | --func | --funct | --functi | --functio | \
  68.   --function | --function- | --function-r | --function-re | --function-rel | \
  69.   --function-relo | --function-reloc | --function-relocs)
  70.     warn=yes
  71.     bind_now=yes
  72.     shift
  73.     ;;
  74.   -v | --verb | --verbo | --verbos | --verbose)
  75.     verbose=yes
  76.     shift
  77.     ;;
  78.   -u | --u | --un | --unu | --unus | --unuse | --unused)
  79.     unused=yes
  80.     shift
  81.     ;;
  82.   --v | --ve | --ver)
  83.     echo >&2 $"ldd: option \`$1' is ambiguous"
  84.     exit 1
  85.     ;;
  86.   --)        # Stop option processing.
  87.     shift; break
  88.     ;;
  89.   -*)
  90.     echo >&2 'ldd:' $"unrecognized option" "\`$1'"
  91.     echo >&2 $"Try \`ldd --help' for more information."
  92.     exit 1
  93.     ;;
  94.   *)
  95.     break
  96.     ;;
  97.   esac
  98. done
  99.  
  100. nonelf ()
  101. {
  102.   # Maybe extra code for non-ELF binaries.
  103.   return 1;
  104. }
  105.  
  106. add_env="LD_TRACE_LOADED_OBJECTS=1 LD_WARN=$warn LD_BIND_NOW=$bind_now"
  107. add_env="$add_env LD_LIBRARY_VERSION=\$verify_out"
  108. add_env="$add_env LD_VERBOSE=$verbose"
  109. if test "$unused" = yes; then
  110.   add_env="$add_env LD_DEBUG=\"$LD_DEBUG${LD_DEBUG:+,}unused\""
  111. fi
  112.  
  113. # The following use of cat is needed to make ldd work in SELinux
  114. # environments where the executed program might not have permissions
  115. # to write to the console/tty.  But only bash 3.x supports the pipefail
  116. # option, and we don't bother to handle the case for older bash versions.
  117. if x=`set -o` && test "$x" != "${x#*pipefail}" && set -o pipefail ; then
  118.   try_trace() {
  119.     eval $add_env '"$@"' | cat
  120.   }
  121. else
  122.   try_trace() {
  123.     eval $add_env '"$@"'
  124.   }
  125. fi
  126.  
  127. case $# in
  128. 0)
  129.   echo >&2 'ldd:' $"missing file arguments"
  130.   echo >&2 $"Try \`ldd --help' for more information."
  131.   exit 1
  132.   ;;
  133. 1)
  134.   single_file=t
  135.   ;;
  136. *)
  137.   single_file=f
  138.   ;;
  139. esac
  140.  
  141. result=0
  142. for file do
  143.   # We don't list the file name when there is only one.
  144.   test $single_file = t || echo "${file}:"
  145.   case $file in
  146.   */*) :
  147.        ;;
  148.   *) file=./$file
  149.      ;;
  150.   esac
  151.   if test ! -e "$file"; then
  152.     echo "ldd: ${file}:" $"No such file or directory" >&2
  153.     result=1
  154.   elif test ! -f "$file"; then
  155.     echo "ldd: ${file}:" $"not regular file" >&2
  156.     result=1
  157.   elif test -r "$file"; then
  158.     if test ! -x "$file" && eval echo "$file" \
  159.     | egrep -v "$filename_magic_regex" > /dev/null; then
  160.     echo 'ldd:' $"warning: you do not have execution permission for"\
  161.         "\`$file'" >&2
  162.     fi
  163.     RTLD=
  164.     ret=1
  165.     for rtld in ${RTLDLIST}; do
  166.       if test -x $rtld; then
  167.     verify_out=`${rtld} --verify "$file" 2>/dev/null`
  168.         ret=$?
  169.     case $ret in
  170.     [02]) RTLD=${rtld}; break;;
  171.     esac
  172.       fi
  173.     done
  174.     case $ret in
  175.     0)
  176.       # If the program exits with exit code 5, it means the process has been
  177.       # invoked with __libc_enable_secure.  Fall back to running it through
  178.       # the dynamic linker.
  179.       if test -x "$file"; then
  180.     try_trace "$file"
  181.       else
  182.     try_trace "${RTLD}" "$file"
  183.       fi
  184.       rc=$?
  185.       if [ $rc = 5 ]; then
  186.     try_trace "$RTLD" "$file"
  187.     rc=$?
  188.       fi
  189.       [ $rc = 0 ] || result=1
  190.       ;;
  191.     1)
  192.       # This can be a non-ELF binary or no binary at all.
  193.       nonelf "$file" || {
  194.     echo $"    not a dynamic executable"
  195.     result=1
  196.       }
  197.       ;;
  198.     2)
  199.       try_trace "$RTLD" "$file" || result=1
  200.       ;;
  201.     *)
  202.       echo 'ldd:' ${RTLD} $"exited with unknown exit code" "($ret)" >&2
  203.       exit 1
  204.       ;;
  205.     esac
  206.   else
  207.     echo 'ldd:' $"error: you do not have read permission for" "\`$file'" >&2
  208.     result=1
  209.   fi
  210. done
  211.  
  212. exit $result
  213. # Local Variables:
  214. #  mode:ksh
  215. # End:
  216.